= nng_pipe_close(3)
//
// Copyright 2018 Staysail Systems, Inc. <info@staysail.tech>
// Copyright 2018 Capitar IT Group BV <info@capitar.com>
//
// This document is supplied under the terms of the MIT License, a
// copy of which should be located in the distribution where this
// file was obtained (LICENSE.txt).  A copy of the license may also be
// found online at https://opensource.org/licenses/MIT.
//

== NAME

nng_pipe_close - close pipe

== SYNOPSIS

[source, c]
----
#include <nng/nng.h>

int nng_pipe_close(nng_pipe p);
----

== DESCRIPTION

The `nng_pipe_close()` function closes the supplied pipe, _p_.
Messages that have been submitted for sending may be flushed or delivered,
depending upon the transport.

Further attempts to use the pipe after this call returns will result
in `NNG_ECLOSED`.

TIP: Pipes are automatically closed when their creator closes, or when the
remote peer closes the underlying connection.

== RETURN VALUES

This function returns 0 on success, and non-zero otherwise.

== ERRORS

[horizontal]
`NNG_ECLOSED`:: The pipe _p_ is already closed or was never opened.

== SEE ALSO

[.text-left]
xref:nng_strerror.3.adoc[nng_strerror(3)],
xref:nng_options.5.adoc[nng_options(5)],
xref:nng_pipe.5.adoc[nng_pipe(5)],
xref:nng.7.adoc[nng(7)]
